# client.py (Run on computer B)
import socket
import keyboard
import time

def run_client():
    client = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    
    # Connect to server - modify with actual IP of computer A
    SERVER_IP = '100.64.1.63'  # Replace with computer A's IP address
    PORT = 12345
    
    print(f"Connecting to server at {SERVER_IP}:{PORT}...")
    client.connect((SERVER_IP, PORT))
    print("Connected to server")
    
    # Reverse mapping for key codes
    code_to_key = {
        b'0': 'w',
        b'1': 'a',
        b'2': 's',
        b'3': 'd',
        b'4': 'e',
        b'5': 'r',
        b'6': 'f',
        b'7': '1',
        b'8': '2',
        b'9': 'space'
    }
    
    def safe_release(key):
        try:
            keyboard.release(key)
        except:
            pass

    try:
        while True:
            # Each message is exactly 2 bytes
            data = client.recv(2)
            if not data or len(data) != 2:
                break
                
            key_code = data[0:1]  # First byte is key code
            is_down = data[1:2] == b'1'  # Second byte is event type
            
            if key_code in code_to_key:
                key = code_to_key[key_code]
                if is_down:
                    keyboard.press(key)
                else:
                    safe_release(key)
    
    except Exception as e:
        print(f"Connection error: {e}")
    finally:
        # Release all keys on exit
        for key in code_to_key.values():
            safe_release(key)
        client.close()
        print("Client shutdown complete")

if __name__ == "__main__":
    run_client()
